/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PricingTipoServicioDAO;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingTipoServicio;
import com.rjconsultores.ventaboletos.entidad.TipoServicio;
import com.rjconsultores.ventaboletos.service.PricingTipoServicioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * 
 * @author Desenvolvimento
 */
@Service("pricingTipoServicioService")
public class PricingTipoServicioServiceImpl implements PricingTipoServicioService {

	@Autowired
	private PricingTipoServicioDAO pricingTipoServicioDAO;

	public List<PricingTipoServicio> obtenerTodos() {
		return pricingTipoServicioDAO.obtenerTodos();
	}

	public PricingTipoServicio obtenerID(Integer id) {
		return pricingTipoServicioDAO.obtenerID(id);
	}

	@Transactional
	public PricingTipoServicio suscribir(PricingTipoServicio entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Pricing.ATIVO);

		return pricingTipoServicioDAO.suscribir(entidad);
	}

	@Transactional
	public PricingTipoServicio actualizacion(PricingTipoServicio entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Pricing.ATIVO);

		return pricingTipoServicioDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(PricingTipoServicio entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Pricing.EXCLUIDO);

		pricingTipoServicioDAO.actualizacion(entidad);
	}

	public Boolean obtenerPricingTipoServicio(Pricing pricing, TipoServicio tipoServicio) {
		return pricingTipoServicioDAO.obtenerPricingTipoServicio(pricing, tipoServicio);
	}

	@Override
	@Transactional
	public void borrar(List<PricingTipoServicio> pricingTipoServicios) {
		if(pricingTipoServicios != null && !pricingTipoServicios.isEmpty()) {
			for (PricingTipoServicio pricingTipoServicio : pricingTipoServicios) {
				borrar(pricingTipoServicio);
			}
		}
	}
}
